/*------------------------------------------------------------------------
--                                                                      --
--                     H E L I O S   K E R N E L                        --
--                     -------------------------                        --
--                                                                      --
--             Copyright (C) 1987, Perihelion Software Ltd.             --
--                        All Rights Reserved.                          --
--                                                                      --
-- event.h								--
--                                                                      --
--	Event channel support.						--
--                                                                      --
--	Author:  NHG 8/8/88						--
--                                                                      --
------------------------------------------------------------------------*/
/* SccsId: %W%	%G% Copyright (C) 1987, Perihelion Software Ltd.	*/
/* $Id: event.h,v 1.9 1992/09/25 09:09:32 paul Exp $ */

#ifndef __event_h
#define __event_h

#ifndef __helios_h
# include <helios.h>
#endif

#ifdef __C40
# include <c40.h>
#endif

typedef struct Event {
	struct Node	Node;		/* link in event chain		*/
#ifdef __TRAN
	word		Pri;		/* priority in chain		*/
	VoidFnPtr	Code;		/* event routine		*/
#else
	word		Vector;		/* interrupt vector		*/
	word		Pri;		/* priority in chain		*/
	WordFnPtr	Code;		/* event routine		*/
# ifdef __C40
	word		AddrBase;	/* C data address base		*/
# endif
#endif
	void		*Data;		/* data for this		*/
	word		*ModTab;	/* set by kernel		*/
} Event;


/* Kernel support routines */

word SetEvent(Event *event);
word RemEvent(Event *event);

#ifdef __ABC
 /* user event mechanism prototypes */
 word SetUserEvent(Event *event);
 word RemUserEvent(Event *event);
 void CauseUserEvent(word vector, word arg);
#endif
#ifndef __TRAN
 /* disable interrupts for the duration of this fn call */
 word AvoidEvents(WordFnPtr fn, ...);

 /* Set new system stack, either to increase its size or place into faster */
 /* (possibly on-chip) memory. NULL newsysstk just returns old stack address. */
# ifdef __C40
 wordptr SetSystemStack(wordptr newsysstk);
# else
 word *SetSystemStack(word *newsysstk);
# endif
#endif

#ifdef __C40
/* direct mainipulation of status and IIE registers via embedded machine code */
# define IntsOff()	_word(0x03752000)	/* or	ST_GIE, st	*/
# define IntsOn()	_word(0x10752000)	/* andn	ST_GIE, st	*/

# define ClockIntsOff()	_word(0x03770001)	/* or	IIE_ETINT0, st	*/
# define ClockIntsOn()	_word(0x10770001)	/* andn IIE_ETINT0, st	*/

/* more optimal version of AvoidEvents() (fixed 3 parameters) */
# define _AvoidEvents(aefn, a,b,c)	IntsOff(); \
					((WordFnPtr)aefn)(a,b,c); \
					IntsOn()
#endif

#endif


/* -- End of event.h */
