/*------------------------------------------------------------------------
--                                                                      --
--                     H E L I O S   N U C L E U S                      --
--                     ---------------------------                      --
--                                                                      --
--             Copyright (C) 1987, Perihelion Software Ltd.             --
--                        All Rights Reserved.                          --
--                                                                      --
-- queue.h								--
--                                                                      --
--	
--                                                                      --
--	Author:  NHG 16/8/87						--
--                                                                      --
------------------------------------------------------------------------*/
/* SccsId: %W% %G% Copyright (C) 1987, Perihelion Software Ltd.	*/
/* $Id: queue.h,v 1.1 90/09/05 11:07:03 nick Exp $ */

#ifndef __queue_h
#define __queue_h

#ifndef __helios_h
#include <helios.h>
#endif


typedef struct List {
	struct Node	*Head;		/* list head pointer		*/
	struct Node	*Earth;		/* NULL pointer			*/
	struct Node	*Tail;		/* list tail pointer		*/
} List;

typedef struct Node {
	struct Node	*Next;		/* next item in list		*/
	struct Node	*Prev;		/* previous item in list	*/
} Node;

PUBLIC void InitList(List *);
PUBLIC void PreInsert(Node *, Node *);
PUBLIC void PostInsert(Node *, Node *);
PUBLIC Node *Remove(Node *);
PUBLIC void AddHead(List *, Node *);
PUBLIC void AddTail(List *, Node *);
PUBLIC Node *RemHead(List *);
PUBLIC Node *RemTail(List *);
PUBLIC word WalkList(List *,WordFnPtr,...);
PUBLIC Node *SearchList(List *,WordFnPtr,...);

/* some useful macros */

#define EmptyList_(l) ((l).Head == (Node *)&((l).Earth))
#define EndOfList_(n) (((Node *)n)->Next == NULL)
#define Next_(type,n) ((type *)(((Node *)n)->Next))
#define Prev_(type,n) ((type *)(((Node *)n)->Prev))
#define Head_(type,l) ((type *)(((List)l).Head))
#define Tail_(type,l) ((type *)(((List)l).Tail))

#endif

/* -- End of queue.h */
